// -------------------------------------------------------------
//
// Module: Hhilb
// Generated by MATLAB(R) 9.4 and Filter Design HDL Coder 3.1.3.
// Generated on: 2018-05-08 10:49:13
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// Name: Hhilb
// SerialPartition: 50
// TargetLanguage: Verilog
// TestBenchName: Hhilb_tb
// TestBenchStimulus: impulse step ramp chirp noise 
// GenerateHDLTestBench: off

// Filter Specifications:
//
// Sample Rate      : N/A (normalized frequency)
// Response         : Hilbert Transformer
// Specification    : N,TW
// Transition Width : 0.1
// Filter Order     : 100
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Implementation    : Fully Serial
// Folding Factor        : 50
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Filter (real)
// -------------------------------
// Filter Structure  : Direct-Form FIR
// Filter Length     : 101
// Stable            : Yes
// Linear Phase      : Yes (Type 3)
// Arithmetic        : fixed
// Numerator         : s24,23 -> [-1 1)
// Input             : s24,23 -> [-1 1)
// Filter Internals  : Specify Precision
//   Output          : s24,22 -> [-2 2)
//   Product         : s23,22 -> [-1 1)
//   Accumulator     : s24,22 -> [-2 2)
//   Round Mode      : convergent
//   Overflow Mode   : wrap
// -------------------------------------------------------------




`timescale 1 ns / 1 ns

module Hhilb
               (
                clk,
                clk_enable,
                reset,
                filter_in,
                filter_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   signed [23:0] filter_in; //sfix24_En23
  output  signed [23:0] filter_out; //sfix24_En22

////////////////////////////////////////////////////////////////
//Module Architecture: Hhilb
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [23:0] coeff1 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff2 = 24'b111111111111101110111001; //sfix24_En23
  parameter signed [23:0] coeff3 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff4 = 24'b111111111111100101011001; //sfix24_En23
  parameter signed [23:0] coeff5 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff6 = 24'b111111111111010001100000; //sfix24_En23
  parameter signed [23:0] coeff7 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff8 = 24'b111111111110110100100110; //sfix24_En23
  parameter signed [23:0] coeff9 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff10 = 24'b111111111110001100001010; //sfix24_En23
  parameter signed [23:0] coeff11 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff12 = 24'b111111111101010101001011; //sfix24_En23
  parameter signed [23:0] coeff13 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff14 = 24'b111111111100001100010010; //sfix24_En23
  parameter signed [23:0] coeff15 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff16 = 24'b111111111010101101100111; //sfix24_En23
  parameter signed [23:0] coeff17 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff18 = 24'b111111111000110100110000; //sfix24_En23
  parameter signed [23:0] coeff19 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff20 = 24'b111111110110011100101010; //sfix24_En23
  parameter signed [23:0] coeff21 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff22 = 24'b111111110011011111100100; //sfix24_En23
  parameter signed [23:0] coeff23 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff24 = 24'b111111101111110110101010; //sfix24_En23
  parameter signed [23:0] coeff25 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff26 = 24'b111111101011011001110000; //sfix24_En23
  parameter signed [23:0] coeff27 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff28 = 24'b111111100101111110101000; //sfix24_En23
  parameter signed [23:0] coeff29 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff30 = 24'b111111011111011000000100; //sfix24_En23
  parameter signed [23:0] coeff31 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff32 = 24'b111111010111010100000010; //sfix24_En23
  parameter signed [23:0] coeff33 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff34 = 24'b111111001101011000110000; //sfix24_En23
  parameter signed [23:0] coeff35 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff36 = 24'b111111000000111111010000; //sfix24_En23
  parameter signed [23:0] coeff37 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff38 = 24'b111110110001001000110011; //sfix24_En23
  parameter signed [23:0] coeff39 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff40 = 24'b111110011100001000111101; //sfix24_En23
  parameter signed [23:0] coeff41 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff42 = 24'b111101111110110010000101; //sfix24_En23
  parameter signed [23:0] coeff43 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff44 = 24'b111101010010001001111001; //sfix24_En23
  parameter signed [23:0] coeff45 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff46 = 24'b111100000100001111001011; //sfix24_En23
  parameter signed [23:0] coeff47 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff48 = 24'b111001010010110110100010; //sfix24_En23
  parameter signed [23:0] coeff49 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff50 = 24'b101011101010000001110101; //sfix24_En23
  parameter signed [23:0] coeff51 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff52 = 24'b010100010101111110001011; //sfix24_En23
  parameter signed [23:0] coeff53 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff54 = 24'b000110101101001001011110; //sfix24_En23
  parameter signed [23:0] coeff55 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff56 = 24'b000011111011110000110101; //sfix24_En23
  parameter signed [23:0] coeff57 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff58 = 24'b000010101101110110000111; //sfix24_En23
  parameter signed [23:0] coeff59 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff60 = 24'b000010000001001101111011; //sfix24_En23
  parameter signed [23:0] coeff61 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff62 = 24'b000001100011110111000011; //sfix24_En23
  parameter signed [23:0] coeff63 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff64 = 24'b000001001110110111001101; //sfix24_En23
  parameter signed [23:0] coeff65 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff66 = 24'b000000111111000000110000; //sfix24_En23
  parameter signed [23:0] coeff67 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff68 = 24'b000000110010100111010000; //sfix24_En23
  parameter signed [23:0] coeff69 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff70 = 24'b000000101000101011111110; //sfix24_En23
  parameter signed [23:0] coeff71 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff72 = 24'b000000100000100111111100; //sfix24_En23
  parameter signed [23:0] coeff73 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff74 = 24'b000000011010000001011000; //sfix24_En23
  parameter signed [23:0] coeff75 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff76 = 24'b000000010100100110010000; //sfix24_En23
  parameter signed [23:0] coeff77 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff78 = 24'b000000010000001001010110; //sfix24_En23
  parameter signed [23:0] coeff79 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff80 = 24'b000000001100100000011100; //sfix24_En23
  parameter signed [23:0] coeff81 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff82 = 24'b000000001001100011010110; //sfix24_En23
  parameter signed [23:0] coeff83 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff84 = 24'b000000000111001011010000; //sfix24_En23
  parameter signed [23:0] coeff85 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff86 = 24'b000000000101010010011001; //sfix24_En23
  parameter signed [23:0] coeff87 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff88 = 24'b000000000011110011101110; //sfix24_En23
  parameter signed [23:0] coeff89 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff90 = 24'b000000000010101010110101; //sfix24_En23
  parameter signed [23:0] coeff91 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff92 = 24'b000000000001110011110110; //sfix24_En23
  parameter signed [23:0] coeff93 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff94 = 24'b000000000001001011011010; //sfix24_En23
  parameter signed [23:0] coeff95 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff96 = 24'b000000000000101110100000; //sfix24_En23
  parameter signed [23:0] coeff97 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff98 = 24'b000000000000011010100111; //sfix24_En23
  parameter signed [23:0] coeff99 = 24'b000000000000000000000000; //sfix24_En23
  parameter signed [23:0] coeff100 = 24'b000000000000010001000111; //sfix24_En23
  parameter signed [23:0] coeff101 = 24'b000000000000000000000000; //sfix24_En23

  // Signals
  reg  [5:0] cur_count; // ufix6
  wire phase_49; // boolean
  wire phase_0; // boolean
  reg  signed [23:0] delay_pipeline [0:100] ; // sfix24_En23
  wire signed [23:0] inputmux_1; // sfix24_En23
  reg  signed [23:0] acc_final; // sfix24_En22
  reg  signed [23:0] acc_out_1; // sfix24_En22
  wire signed [22:0] product_1; // sfix23_En22
  wire signed [23:0] product_1_mux; // sfix24_En23
  wire signed [47:0] mul_temp; // sfix48_En46
  wire signed [23:0] prod_typeconvert_1; // sfix24_En22
  wire signed [23:0] acc_sum_1; // sfix24_En22
  wire signed [23:0] acc_in_1; // sfix24_En22
  wire signed [23:0] add_signext; // sfix24_En22
  wire signed [23:0] add_signext_1; // sfix24_En22
  wire signed [24:0] add_temp; // sfix25_En22
  reg  signed [23:0] output_register; // sfix24_En22

  // Block Statements
  always @ (posedge clk or posedge reset)
    begin: Counter_process
      if (reset == 1'b1) begin
        cur_count <= 6'b110001;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count >= 6'b110001) begin
            cur_count <= 6'b000000;
          end
          else begin
            cur_count <= cur_count + 6'b000001;
          end
        end
      end
    end // Counter_process

  assign  phase_49 = (cur_count == 6'b110001 && clk_enable == 1'b1) ? 1'b1 : 1'b0;

  assign  phase_0 = (cur_count == 6'b000000 && clk_enable == 1'b1) ? 1'b1 : 1'b0;

  always @( posedge clk or posedge reset)
    begin: Delay_Pipeline_process
      if (reset == 1'b1) begin
        delay_pipeline[0] <= 0;
        delay_pipeline[1] <= 0;
        delay_pipeline[2] <= 0;
        delay_pipeline[3] <= 0;
        delay_pipeline[4] <= 0;
        delay_pipeline[5] <= 0;
        delay_pipeline[6] <= 0;
        delay_pipeline[7] <= 0;
        delay_pipeline[8] <= 0;
        delay_pipeline[9] <= 0;
        delay_pipeline[10] <= 0;
        delay_pipeline[11] <= 0;
        delay_pipeline[12] <= 0;
        delay_pipeline[13] <= 0;
        delay_pipeline[14] <= 0;
        delay_pipeline[15] <= 0;
        delay_pipeline[16] <= 0;
        delay_pipeline[17] <= 0;
        delay_pipeline[18] <= 0;
        delay_pipeline[19] <= 0;
        delay_pipeline[20] <= 0;
        delay_pipeline[21] <= 0;
        delay_pipeline[22] <= 0;
        delay_pipeline[23] <= 0;
        delay_pipeline[24] <= 0;
        delay_pipeline[25] <= 0;
        delay_pipeline[26] <= 0;
        delay_pipeline[27] <= 0;
        delay_pipeline[28] <= 0;
        delay_pipeline[29] <= 0;
        delay_pipeline[30] <= 0;
        delay_pipeline[31] <= 0;
        delay_pipeline[32] <= 0;
        delay_pipeline[33] <= 0;
        delay_pipeline[34] <= 0;
        delay_pipeline[35] <= 0;
        delay_pipeline[36] <= 0;
        delay_pipeline[37] <= 0;
        delay_pipeline[38] <= 0;
        delay_pipeline[39] <= 0;
        delay_pipeline[40] <= 0;
        delay_pipeline[41] <= 0;
        delay_pipeline[42] <= 0;
        delay_pipeline[43] <= 0;
        delay_pipeline[44] <= 0;
        delay_pipeline[45] <= 0;
        delay_pipeline[46] <= 0;
        delay_pipeline[47] <= 0;
        delay_pipeline[48] <= 0;
        delay_pipeline[49] <= 0;
        delay_pipeline[50] <= 0;
        delay_pipeline[51] <= 0;
        delay_pipeline[52] <= 0;
        delay_pipeline[53] <= 0;
        delay_pipeline[54] <= 0;
        delay_pipeline[55] <= 0;
        delay_pipeline[56] <= 0;
        delay_pipeline[57] <= 0;
        delay_pipeline[58] <= 0;
        delay_pipeline[59] <= 0;
        delay_pipeline[60] <= 0;
        delay_pipeline[61] <= 0;
        delay_pipeline[62] <= 0;
        delay_pipeline[63] <= 0;
        delay_pipeline[64] <= 0;
        delay_pipeline[65] <= 0;
        delay_pipeline[66] <= 0;
        delay_pipeline[67] <= 0;
        delay_pipeline[68] <= 0;
        delay_pipeline[69] <= 0;
        delay_pipeline[70] <= 0;
        delay_pipeline[71] <= 0;
        delay_pipeline[72] <= 0;
        delay_pipeline[73] <= 0;
        delay_pipeline[74] <= 0;
        delay_pipeline[75] <= 0;
        delay_pipeline[76] <= 0;
        delay_pipeline[77] <= 0;
        delay_pipeline[78] <= 0;
        delay_pipeline[79] <= 0;
        delay_pipeline[80] <= 0;
        delay_pipeline[81] <= 0;
        delay_pipeline[82] <= 0;
        delay_pipeline[83] <= 0;
        delay_pipeline[84] <= 0;
        delay_pipeline[85] <= 0;
        delay_pipeline[86] <= 0;
        delay_pipeline[87] <= 0;
        delay_pipeline[88] <= 0;
        delay_pipeline[89] <= 0;
        delay_pipeline[90] <= 0;
        delay_pipeline[91] <= 0;
        delay_pipeline[92] <= 0;
        delay_pipeline[93] <= 0;
        delay_pipeline[94] <= 0;
        delay_pipeline[95] <= 0;
        delay_pipeline[96] <= 0;
        delay_pipeline[97] <= 0;
        delay_pipeline[98] <= 0;
        delay_pipeline[99] <= 0;
        delay_pipeline[100] <= 0;
      end
      else begin
        if (phase_49 == 1'b1) begin
          delay_pipeline[0] <= filter_in;
          delay_pipeline[1] <= delay_pipeline[0];
          delay_pipeline[2] <= delay_pipeline[1];
          delay_pipeline[3] <= delay_pipeline[2];
          delay_pipeline[4] <= delay_pipeline[3];
          delay_pipeline[5] <= delay_pipeline[4];
          delay_pipeline[6] <= delay_pipeline[5];
          delay_pipeline[7] <= delay_pipeline[6];
          delay_pipeline[8] <= delay_pipeline[7];
          delay_pipeline[9] <= delay_pipeline[8];
          delay_pipeline[10] <= delay_pipeline[9];
          delay_pipeline[11] <= delay_pipeline[10];
          delay_pipeline[12] <= delay_pipeline[11];
          delay_pipeline[13] <= delay_pipeline[12];
          delay_pipeline[14] <= delay_pipeline[13];
          delay_pipeline[15] <= delay_pipeline[14];
          delay_pipeline[16] <= delay_pipeline[15];
          delay_pipeline[17] <= delay_pipeline[16];
          delay_pipeline[18] <= delay_pipeline[17];
          delay_pipeline[19] <= delay_pipeline[18];
          delay_pipeline[20] <= delay_pipeline[19];
          delay_pipeline[21] <= delay_pipeline[20];
          delay_pipeline[22] <= delay_pipeline[21];
          delay_pipeline[23] <= delay_pipeline[22];
          delay_pipeline[24] <= delay_pipeline[23];
          delay_pipeline[25] <= delay_pipeline[24];
          delay_pipeline[26] <= delay_pipeline[25];
          delay_pipeline[27] <= delay_pipeline[26];
          delay_pipeline[28] <= delay_pipeline[27];
          delay_pipeline[29] <= delay_pipeline[28];
          delay_pipeline[30] <= delay_pipeline[29];
          delay_pipeline[31] <= delay_pipeline[30];
          delay_pipeline[32] <= delay_pipeline[31];
          delay_pipeline[33] <= delay_pipeline[32];
          delay_pipeline[34] <= delay_pipeline[33];
          delay_pipeline[35] <= delay_pipeline[34];
          delay_pipeline[36] <= delay_pipeline[35];
          delay_pipeline[37] <= delay_pipeline[36];
          delay_pipeline[38] <= delay_pipeline[37];
          delay_pipeline[39] <= delay_pipeline[38];
          delay_pipeline[40] <= delay_pipeline[39];
          delay_pipeline[41] <= delay_pipeline[40];
          delay_pipeline[42] <= delay_pipeline[41];
          delay_pipeline[43] <= delay_pipeline[42];
          delay_pipeline[44] <= delay_pipeline[43];
          delay_pipeline[45] <= delay_pipeline[44];
          delay_pipeline[46] <= delay_pipeline[45];
          delay_pipeline[47] <= delay_pipeline[46];
          delay_pipeline[48] <= delay_pipeline[47];
          delay_pipeline[49] <= delay_pipeline[48];
          delay_pipeline[50] <= delay_pipeline[49];
          delay_pipeline[51] <= delay_pipeline[50];
          delay_pipeline[52] <= delay_pipeline[51];
          delay_pipeline[53] <= delay_pipeline[52];
          delay_pipeline[54] <= delay_pipeline[53];
          delay_pipeline[55] <= delay_pipeline[54];
          delay_pipeline[56] <= delay_pipeline[55];
          delay_pipeline[57] <= delay_pipeline[56];
          delay_pipeline[58] <= delay_pipeline[57];
          delay_pipeline[59] <= delay_pipeline[58];
          delay_pipeline[60] <= delay_pipeline[59];
          delay_pipeline[61] <= delay_pipeline[60];
          delay_pipeline[62] <= delay_pipeline[61];
          delay_pipeline[63] <= delay_pipeline[62];
          delay_pipeline[64] <= delay_pipeline[63];
          delay_pipeline[65] <= delay_pipeline[64];
          delay_pipeline[66] <= delay_pipeline[65];
          delay_pipeline[67] <= delay_pipeline[66];
          delay_pipeline[68] <= delay_pipeline[67];
          delay_pipeline[69] <= delay_pipeline[68];
          delay_pipeline[70] <= delay_pipeline[69];
          delay_pipeline[71] <= delay_pipeline[70];
          delay_pipeline[72] <= delay_pipeline[71];
          delay_pipeline[73] <= delay_pipeline[72];
          delay_pipeline[74] <= delay_pipeline[73];
          delay_pipeline[75] <= delay_pipeline[74];
          delay_pipeline[76] <= delay_pipeline[75];
          delay_pipeline[77] <= delay_pipeline[76];
          delay_pipeline[78] <= delay_pipeline[77];
          delay_pipeline[79] <= delay_pipeline[78];
          delay_pipeline[80] <= delay_pipeline[79];
          delay_pipeline[81] <= delay_pipeline[80];
          delay_pipeline[82] <= delay_pipeline[81];
          delay_pipeline[83] <= delay_pipeline[82];
          delay_pipeline[84] <= delay_pipeline[83];
          delay_pipeline[85] <= delay_pipeline[84];
          delay_pipeline[86] <= delay_pipeline[85];
          delay_pipeline[87] <= delay_pipeline[86];
          delay_pipeline[88] <= delay_pipeline[87];
          delay_pipeline[89] <= delay_pipeline[88];
          delay_pipeline[90] <= delay_pipeline[89];
          delay_pipeline[91] <= delay_pipeline[90];
          delay_pipeline[92] <= delay_pipeline[91];
          delay_pipeline[93] <= delay_pipeline[92];
          delay_pipeline[94] <= delay_pipeline[93];
          delay_pipeline[95] <= delay_pipeline[94];
          delay_pipeline[96] <= delay_pipeline[95];
          delay_pipeline[97] <= delay_pipeline[96];
          delay_pipeline[98] <= delay_pipeline[97];
          delay_pipeline[99] <= delay_pipeline[98];
          delay_pipeline[100] <= delay_pipeline[99];
        end
      end
    end // Delay_Pipeline_process


  assign inputmux_1 = (cur_count == 6'b000000) ? delay_pipeline[1] :
                     (cur_count == 6'b000001) ? delay_pipeline[3] :
                     (cur_count == 6'b000010) ? delay_pipeline[5] :
                     (cur_count == 6'b000011) ? delay_pipeline[7] :
                     (cur_count == 6'b000100) ? delay_pipeline[9] :
                     (cur_count == 6'b000101) ? delay_pipeline[11] :
                     (cur_count == 6'b000110) ? delay_pipeline[13] :
                     (cur_count == 6'b000111) ? delay_pipeline[15] :
                     (cur_count == 6'b001000) ? delay_pipeline[17] :
                     (cur_count == 6'b001001) ? delay_pipeline[19] :
                     (cur_count == 6'b001010) ? delay_pipeline[21] :
                     (cur_count == 6'b001011) ? delay_pipeline[23] :
                     (cur_count == 6'b001100) ? delay_pipeline[25] :
                     (cur_count == 6'b001101) ? delay_pipeline[27] :
                     (cur_count == 6'b001110) ? delay_pipeline[29] :
                     (cur_count == 6'b001111) ? delay_pipeline[31] :
                     (cur_count == 6'b010000) ? delay_pipeline[33] :
                     (cur_count == 6'b010001) ? delay_pipeline[35] :
                     (cur_count == 6'b010010) ? delay_pipeline[37] :
                     (cur_count == 6'b010011) ? delay_pipeline[39] :
                     (cur_count == 6'b010100) ? delay_pipeline[41] :
                     (cur_count == 6'b010101) ? delay_pipeline[43] :
                     (cur_count == 6'b010110) ? delay_pipeline[45] :
                     (cur_count == 6'b010111) ? delay_pipeline[47] :
                     (cur_count == 6'b011000) ? delay_pipeline[49] :
                     (cur_count == 6'b011001) ? delay_pipeline[51] :
                     (cur_count == 6'b011010) ? delay_pipeline[53] :
                     (cur_count == 6'b011011) ? delay_pipeline[55] :
                     (cur_count == 6'b011100) ? delay_pipeline[57] :
                     (cur_count == 6'b011101) ? delay_pipeline[59] :
                     (cur_count == 6'b011110) ? delay_pipeline[61] :
                     (cur_count == 6'b011111) ? delay_pipeline[63] :
                     (cur_count == 6'b100000) ? delay_pipeline[65] :
                     (cur_count == 6'b100001) ? delay_pipeline[67] :
                     (cur_count == 6'b100010) ? delay_pipeline[69] :
                     (cur_count == 6'b100011) ? delay_pipeline[71] :
                     (cur_count == 6'b100100) ? delay_pipeline[73] :
                     (cur_count == 6'b100101) ? delay_pipeline[75] :
                     (cur_count == 6'b100110) ? delay_pipeline[77] :
                     (cur_count == 6'b100111) ? delay_pipeline[79] :
                     (cur_count == 6'b101000) ? delay_pipeline[81] :
                     (cur_count == 6'b101001) ? delay_pipeline[83] :
                     (cur_count == 6'b101010) ? delay_pipeline[85] :
                     (cur_count == 6'b101011) ? delay_pipeline[87] :
                     (cur_count == 6'b101100) ? delay_pipeline[89] :
                     (cur_count == 6'b101101) ? delay_pipeline[91] :
                     (cur_count == 6'b101110) ? delay_pipeline[93] :
                     (cur_count == 6'b101111) ? delay_pipeline[95] :
                     (cur_count == 6'b110000) ? delay_pipeline[97] :
                     delay_pipeline[99];

  //   ------------------ Serial partition # 1 ------------------

  assign product_1_mux = (cur_count == 6'b000000) ? coeff2 :
                        (cur_count == 6'b000001) ? coeff4 :
                        (cur_count == 6'b000010) ? coeff6 :
                        (cur_count == 6'b000011) ? coeff8 :
                        (cur_count == 6'b000100) ? coeff10 :
                        (cur_count == 6'b000101) ? coeff12 :
                        (cur_count == 6'b000110) ? coeff14 :
                        (cur_count == 6'b000111) ? coeff16 :
                        (cur_count == 6'b001000) ? coeff18 :
                        (cur_count == 6'b001001) ? coeff20 :
                        (cur_count == 6'b001010) ? coeff22 :
                        (cur_count == 6'b001011) ? coeff24 :
                        (cur_count == 6'b001100) ? coeff26 :
                        (cur_count == 6'b001101) ? coeff28 :
                        (cur_count == 6'b001110) ? coeff30 :
                        (cur_count == 6'b001111) ? coeff32 :
                        (cur_count == 6'b010000) ? coeff34 :
                        (cur_count == 6'b010001) ? coeff36 :
                        (cur_count == 6'b010010) ? coeff38 :
                        (cur_count == 6'b010011) ? coeff40 :
                        (cur_count == 6'b010100) ? coeff42 :
                        (cur_count == 6'b010101) ? coeff44 :
                        (cur_count == 6'b010110) ? coeff46 :
                        (cur_count == 6'b010111) ? coeff48 :
                        (cur_count == 6'b011000) ? coeff50 :
                        (cur_count == 6'b011001) ? coeff52 :
                        (cur_count == 6'b011010) ? coeff54 :
                        (cur_count == 6'b011011) ? coeff56 :
                        (cur_count == 6'b011100) ? coeff58 :
                        (cur_count == 6'b011101) ? coeff60 :
                        (cur_count == 6'b011110) ? coeff62 :
                        (cur_count == 6'b011111) ? coeff64 :
                        (cur_count == 6'b100000) ? coeff66 :
                        (cur_count == 6'b100001) ? coeff68 :
                        (cur_count == 6'b100010) ? coeff70 :
                        (cur_count == 6'b100011) ? coeff72 :
                        (cur_count == 6'b100100) ? coeff74 :
                        (cur_count == 6'b100101) ? coeff76 :
                        (cur_count == 6'b100110) ? coeff78 :
                        (cur_count == 6'b100111) ? coeff80 :
                        (cur_count == 6'b101000) ? coeff82 :
                        (cur_count == 6'b101001) ? coeff84 :
                        (cur_count == 6'b101010) ? coeff86 :
                        (cur_count == 6'b101011) ? coeff88 :
                        (cur_count == 6'b101100) ? coeff90 :
                        (cur_count == 6'b101101) ? coeff92 :
                        (cur_count == 6'b101110) ? coeff94 :
                        (cur_count == 6'b101111) ? coeff96 :
                        (cur_count == 6'b110000) ? coeff98 :
                        coeff100;
  assign mul_temp = inputmux_1 * product_1_mux;
  assign product_1 = (mul_temp[46:0] + {mul_temp[24], {23{~mul_temp[24]}}})>>>24;

  assign prod_typeconvert_1 = $signed({{1{product_1[22]}}, product_1});

  assign add_signext = prod_typeconvert_1;
  assign add_signext_1 = acc_out_1;
  assign add_temp = add_signext + add_signext_1;
  assign acc_sum_1 = add_temp[23:0];

  assign acc_in_1 = (phase_0 == 1'b1) ? prod_typeconvert_1 :
                   acc_sum_1;

  always @ (posedge clk or posedge reset)
    begin: Acc_reg_1_process
      if (reset == 1'b1) begin
        acc_out_1 <= 0;
      end
      else begin
        if (clk_enable == 1'b1) begin
          acc_out_1 <= acc_in_1;
        end
      end
    end // Acc_reg_1_process

  always @ (posedge clk or posedge reset)
    begin: Finalsum_reg_process
      if (reset == 1'b1) begin
        acc_final <= 0;
      end
      else begin
        if (phase_0 == 1'b1) begin
          acc_final <= acc_out_1;
        end
      end
    end // Finalsum_reg_process

  always @ (posedge clk or posedge reset)
    begin: Output_Register_process
      if (reset == 1'b1) begin
        output_register <= 0;
      end
      else begin
        if (phase_49 == 1'b1) begin
          output_register <= acc_final;
        end
      end
    end // Output_Register_process

  // Assignment Statements
  assign filter_out = output_register;
endmodule  // Hhilb
